# Getting started

    virtualenv -p python3 env
    env/bin/pip install -r requirements.txt
    PYTHONPATH=. env/bin/python -m ee.tools.read_ltspice_raw demo/reverse-polarity-bak/reverse-polarity_normal.raw

# LTSpice binary format

## 'real' data

The data are a sequence of chunks, one chunk for each point. Each chunk
contain values for all variables. The first variable is a float64,
all the others are float32.

# Checks

Most schematic symbols have a corresponding footprint and physical
part. Some cases where this is not true:

* Antennas and test points that just have a footprint.
* Optional components, either to select/deselect a feature or tune
  something.

  Some of these should be a part of an order (tuning components) but
  shouldn't be installed in the assembly process. Another example:
  headers that the customer can choose to install.

* Test points shouldn't have a part number

* Check that a LEDs color matches the "color" custom field.

# TODOs

* Consistently use `read` and `parse` in function names.
* Consider flattening the module tree.

* Rename some stuff:
  * Rename "distributor" to "supplier"
  * Rename "distributor part number/DPN" to "SKU".
