import argparse
from pathlib import Path

import ee.drawio
import ee.tools

parser = argparse.ArgumentParser()
ee.tools.add_default_argparse_group(parser)

parser.add_argument("--in",
                    dest="in_path",
                    required=True,
                    metavar="XML")

parser.add_argument("--out",
                    required=True,
                    metavar="PART DB")

parser.add_argument("--parts",
                    nargs="*",
                    metavar="PART DB")

args = parser.parse_args()
ee.tools.process_default_argparse_group(args)

parts = args.parts or []
ee.drawio.to_parts(Path(args.in_path), Path(args.out), [Path(path) for path in parts])
# ee.drawio.to_dot(Path(args.in_path), Path(args.out))
