import argparse
from pathlib import Path

import ee.tools
from ee.part.pn_part_search_list import pn_part_search_list

parser = argparse.ArgumentParser()
ee.tools.add_default_argparse_group(parser)

parser.add_argument("--in",
                    dest="in_path",
                    required=True,
                    metavar="PART DB")

parser.add_argument("--out",
                    required=True,
                    metavar="PART DB")

parser.add_argument("--supplier",
                    required=True,
                    metavar="SUPPLIER")

args = parser.parse_args()
ee.tools.process_default_argparse_group(args)

pn_part_search_list(Path(args.in_path), Path(args.out), args.supplier)
